;pin assign
;
;RA0 KXM52 Y-axis
;RA1 LCD E
;RA2 LCD R/W
;RA3 LCD RS

;RB4 LCD DB4
;RB5 LCD DB5
;RB6 LCD DB6
;RB7 LCD DB7

	list		p=16f819
	#include	<p16F819.inc>
	errorlevel	-302

	__CONFIG	_CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_IO 

	cblock	20H
	avc
	avh
	avl
	refh
	refl
	dispbufh
	dispbufl
	dec100
	dec10
	dec1
	PORTBbuf
	PORTAbuf
	DPDT
	CNT1
	CNT2
	CNT3
	CNT4
	cnt20u
	endc

E	SET	1		;LCD STROBE
RW	SET	2		;LCD R/W
RS	SET	3		;LCD RS

;---------------------------------
;	init and main
;---------------------------------
	org     0x000
	goto    init

init
   	bcf		INTCON,GIE		;disable interrupt

	bsf     STATUS,RP0		;select bank 1
	movlw	B'11110001'		;set RA0, 4, 5, 6, 7 as input
	movwf   TRISA
	movlw	B'00001000'		;set RB3 as input
	movwf	TRISB
	movlw	B'01110000'		;int. osc. 8MHz
	movwf	OSCCON
	movlw	B'10001110'		;right aligned, Fosc/2, set RA0 as A/D
	movwf	ADCON1

	bcf     STATUS,RP0		;bank 0
	clrf	PORTA
	clrf	PORTB
	movlw	B'01000000'		;Fosc/16, A/D stop
	movwf	ADCON0

	clrf	PORTBbuf
	clrf	PORTAbuf

	call	LCD_INI			;Reset LCD 
	call	LCD_CLR

	call	reset			;set the reference

main
	movlw	D'4'			;4 times
	movwf	avc
	clrf	avl
	clrf	avh

main_lp
	call	ad_conv			;Get the acceleration

	bsf     STATUS,RP0		;bank 1
	movfw	ADRESL			;get the data
	bcf     STATUS,RP0		;bank 0
	movwf	dispbufl
	movfw	ADRESH
	movwf	dispbufh

	movfw	dispbufl
	addwf	avl,F
	movfw	dispbufh
	btfsc	STATUS,C
	incf	dispbufh,w
	addwf	avh,F

	movlw	D'100'			;wait loop
	movwf	CNT4		
main_wait_lp
	call	TIME1M
	decfsz	CNT4,F
	goto	main_wait_lp

	decfsz	avc,F
	goto	main_lp

	bcf		STATUS,C		;1/4
	rrf		avh,F
	rrf		avl,F
	bcf		STATUS,C
	rrf		avh,F
	rrf		avl,F

	movfw	refl			;dispbuf = dispbuf - ref (16 bits)
	subwf	avl,f
	movfw	refh
	btfss	STATUS,C
	incf	refh,w
	subwf	avh,f

	call	get_slope
	movwf	dispbufl

	call	LCD_disp

	goto	main

;---------------------------------
;	set the reference
;---------------------------------
reset
	MOVLW	080H			;"Init"
	CALL	LCD_CMD
	movlw	'I'
	call	LCD_DATA
	movlw	'n'
	call	LCD_DATA
	movlw	'i'
	call	LCD_DATA
	movlw	't'
	call	LCD_DATA
	movlw	'i'
	call	LCD_DATA
	movlw	'a'
	call	LCD_DATA
	movlw	'l'
	call	LCD_DATA
	movlw	'i'
	call	LCD_DATA
	movlw	'z'
	call	LCD_DATA
	movlw	'i'
	call	LCD_DATA
	movlw	'n'
	call	LCD_DATA
	movlw	'g'
	call	LCD_DATA

	call	ad_conv			;A/D
	bsf     STATUS,RP0		;bank 1
	movfw	ADRESL
	bcf     STATUS,RP0		;bank 0
	movwf	dispbufl
	movfw	ADRESH
	movwf	dispbufh

	movlw	D'100'			;wait loop
	movwf	CNT3		
reset_lp_0
	call	TIME5M
	decfsz	CNT3,F
	goto	reset_lp_0

	call	LCD_CLR			;clear LCD

	movlw	D'100'			;wait loop
	movwf	CNT3		
reset_lp_1
	call	TIME5M
	decfsz	CNT3,F
	goto	reset_lp_1

	call	ad_conv			;A/D
	bsf     STATUS,RP0		;bank 1
	movfw	ADRESL
	bcf     STATUS,RP0		;bank 0
	movwf	refl
	movfw	ADRESH
	movwf	refh

	movfw	refh
	subwf	dispbufh,w		;if ref <> dispbuf(temp) then goto reset
	btfss	STATUS,Z
	goto	reset
	movfw	refl
	subwf	dispbufl,w
	btfss	STATUS,Z
	goto	reset

	return

;---------------------------------
;	To on LCD
;---------------------------------
LCD_disp
	MOVLW	080H		;1 Line 0 colum
	CALL	LCD_CMD

	movlw	'S'			;"Slope:"
	call	LCD_DATA
	movlw	'l'
	call	LCD_DATA
	movlw	'o'
	call	LCD_DATA
	movlw	'p'
	call	LCD_DATA
	movlw	'e'
	call	LCD_DATA
	movlw	':'
	call	LCD_DATA

	movlw	'0'			;'0' in ASCII is stored
	movwf	dec100
	movfw	dispbufl
	movwf	dec1
LCD_disp_10
	movlw	D'100'
	subwf	dec1,w
	btfss	STATUS,C
	goto	LCD_disp_11
	movwf	dec1		;= dec1 - 100		
	incf	dec100,f
	goto	LCD_disp_10
LCD_disp_11

	movlw	'0'
	movwf	dec10
LCD_disp_12
	movlw	D'10'
	subwf	dec1,w
	btfss	STATUS,C
	goto	LCD_disp_13
	movwf	dec1
	incf	dec10,f
	goto	LCD_disp_12
LCD_disp_13

	movlw	'0'			;To ASCII Code
	addwf	dec1,f

	movfw	dec100		;0 suppressing
	sublw	'0'
	btfss	STATUS,Z
	goto	LCD_disp_14
	movlw	' '
	goto	LCD_disp_15	
LCD_disp_14
	movfw	dec100
LCD_disp_15
	call	LCD_DATA

	movfw	dec10
	call	LCD_DATA

	movlw	'.'
	call	LCD_DATA

	movfw	dec1
	call	LCD_DATA

	movlw	'%'
	call	LCD_DATA

	return

;---------------------------------
;	A/D conversion
;---------------------------------
ad_conv
	movlw	B'01000001'	;Fosc/16, RA0=A/D, A/D start
	movwf	ADCON0
	call	wait20u
	bsf		ADCON0,GO
ad_lp
	btfsc	ADCON0,GO
	goto	ad_lp
	movlw	b'01001100'
	movwf	ADCON0
	return

wait20u
	movlw	d'12'
	movwf	cnt20u
wait20_lp
	decfsz	cnt20u,f
	goto	wait20_lp
	return

;---------------------------------
;	get slope
;---------------------------------
	org	0x180
get_slope
	movlw	H'01'		; 100`1FF
	movwf	PCLATH
	movfw	avl
	sublw	D'50'
	btfss	STATUS,C
	retlw	D'255'
	movfw	avl
	addwf	PCL,F

	retlw	D'0'
	retlw	D'5'
	retlw	D'10'
	retlw	D'15'
	retlw	D'20'
	retlw	D'24'
	retlw	D'29'
	retlw	D'34'
	retlw	D'39'
	retlw	D'44'
	retlw	D'49'
	retlw	D'54'
	retlw	D'59'
	retlw	D'64'
	retlw	D'69'
	retlw	D'73'
	retlw	D'78'
	retlw	D'83'
	retlw	D'88'
	retlw	D'93'
	retlw	D'98'
	retlw	D'103'
	retlw	D'108'
	retlw	D'113'
	retlw	D'118'
	retlw	D'123'
	retlw	D'128'
	retlw	D'133'
	retlw	D'138'
	retlw	D'143'
	retlw	D'148'
	retlw	D'153'
	retlw	D'158'
	retlw	D'163'
	retlw	D'168'
	retlw	D'173'
	retlw	D'179'
	retlw	D'184'
	retlw	D'189'
	retlw	D'194'
	retlw	D'199'
	retlw	D'204'
	retlw	D'210'
	retlw	D'215'
	retlw	D'220'
	retlw	D'225'
	retlw	D'230'
	retlw	D'236'
	retlw	D'241'
	retlw	D'246'
	retlw	D'252'

;
;	ȉw dqĤ߂ PIC16FpKChubNxp
;	ՓN  ^ ISBN4-7741-2131-2
;

;****  LCD Data Write  ****
LCD_DATA
	MOVWF	DPDT		;save dat
	MOVF	DPDT,W		;output upper
;
	andlw	H'F0'
	iorwf	PORTBbuf,w
;
	MOVWF	PORTB
	BCF		PORTA,RW	;R/W
	BSF		PORTA,RS	;RS high
	BSF		PORTA,E		;E high
	BCF		PORTA,E		;E low
	SWAPF	DPDT,W		;output lower
;
	andlw	H'F0'
	iorwf	PORTBbuf,w
;
	MOVWF	PORTB
	BSF		PORTA,E
	BCF		PORTA,E
	CALL	LCD_BUSY
	RETURN

;****  LCD command out  *****
LCD_CMD
	MOVWF	DPDT		;save dat
	MOVF	DPDT,W		;output upper
;
	andlw	H'F0'
	iorwf	PORTBbuf,w
;
	MOVWF	PORTB
	BCF		PORTA,RW	;R/W
	BCF		PORTA,RS	;RS low
	BSF		PORTA,E		;E high
	BCF		PORTA,E		;E low
	SWAPF	DPDT,W		;output lower
;
	andlw	H'F0'
	iorwf	PORTBbuf,w
;
	MOVWF	PORTB
	BSF		PORTA,E
	BCF		PORTA,E
	CALL	LCD_BUSY
	RETURN

;****  LCD Display Clear ****
LCD_CLR
	MOVLW	01H			;clear command
	CALL	LCD_CMD
	RETURN

;****  Initialize  *****
LCD_INI
	CALL	TIME5M		;wait
	MOVLW	030H		;Function set 8bits
	MOVWF	PORTB
	BCF		PORTA,RW	;R/W
	BCF		PORTA,RS	;RS
	BSF		PORTA,E		;E high
	BCF		PORTA,E		;E low
	CALL	TIME5M		;wait
	MOVLW	030H		;Function reset 8bits 
	MOVWF	PORTB
	BCF		PORTA,RW	;R/W
	BCF		PORTA,RS	;RS
	BSF		PORTA,E		;E high
	BCF		PORTA,E		;E low
	CALL	TIME100
	MOVLW	030H		;Function reset 8bits
	MOVWF	PORTB
	BCF		PORTA,RW
	BCF		PORTA,RS
	BSF		PORTA,E
	BCF		PORTA,E
	CALL	TIME100
	MOVLW	020H		;Function set 4bits mode
	MOVWF	PORTB		;under the 8bits mode
	BCF		PORTA,RW
	BCF		PORTA,RS
	BSF		PORTA,E
	BCF		PORTA,E
	CALL	TIME100		;From here 4bits mode

	MOVLW	02EH		;function DL=0 4bit mode
	CALL	LCD_CMD
	MOVLW	08H			;Display off D=C=B=0
	CALL	LCD_CMD
	MOVLW	0CH			;Display on cursor off blink off					;D=C=1 B=0	original = 0DH
	CALL	LCD_CMD
	MOVLW	06H			;Entry I/D=1 S=0
	CALL	LCD_CMD
	RETURN


;****  LCD Busy Check  ************
LCD_BUSY
	BSF		STATUS,RP0	;Bank 1
	MOVLW	0F8H		;PORTB input
	MOVWF	TRISB
	BCF		STATUS,RP0	;Bank 0
	BCF		PORTA,RS	;RS low
	BSF		PORTA,RW	;R/W high
	BSF		PORTA,E		;E high
	MOVF	PORTB,W		;get upper
	BCF		PORTA,E		;E low
	ANDLW	0F0H		;Mask out UPPER
	MOVWF	DPDT
	SWAPF	DPDT,F		;move to lower
	BSF		PORTA,E		;E high
	MOVF	PORTB,W		;get lower
	BCF		PORTA,E		;E low
	ANDLW	0F0H		;Mask out LOWER
	IORWF	DPDT,F		;upper+lower
	SWAPF	DPDT,F
	BTFSC	DPDT,7		;BUSY flag check
	GOTO	LCD_BUSY	;retry

	BCF		PORTA,RW	;R/W low
	BSF		STATUS,RP0	;Bank 1
	movlw	B'00001000'
	movwf	TRISB      	;All of PortB is output except RB3
	BCF		STATUS,RP0	;Bank 0
	RETURN

		
;*********************************
;	Timer Routine
;	TIME10  :10usec
;	TIME100 :100usec
;	TIME1M  :1msec
;	TIME5M  :5msec
;*********************************


TIME100					;100usec
	MOVLW	8H		
	MOVWF	CNT1		
T_LP1
	CALL	TIME10		;2+(26+3)*9-1=262		
	DECFSZ	CNT1,F
	GOTO	T_LP1
	nop
	nop
	movlw	2H
	goto	TIME10_0

TIME10					;10usec
	MOVLW	5H
TIME10_0
	MOVWF	CNT2		
T_LP2
	DECFSZ	CNT2,F		;2+3*7-1=22		
	GOTO	T_LP2		
	RETURN				;22+2=24

TIME1M					;1msec(about)
	MOVLW	0AH
	MOVWF	CNT3
T_LP3
	CALL	TIME100		;2+(266+3)*10-1=2691
	DECFSZ	CNT3,F
	GOTO	T_LP3
	RETURN				;2692

TIME5M					;5msec(about)
	MOVLW	38H
	MOVWF	CNT4
T_LP4
	CALL	TIME100		;2+(266+3)*56-1=15064
	DECFSZ	CNT4,F
	GOTO	T_LP4
	RETURN				;15066

	END


